=== modified file '.bzrignore'
--- .bzrignore	2011-12-23 14:28:12 +0000
+++ .bzrignore	2012-03-14 11:55:04 +0000
@@ -1,14 +1,30 @@
+*.la
+*.lo
+*.stamp
 COPYING
 INSTALL
 Makefile
 Makefile.in
 aclocal.m4
 autom4te.cache/
+config.guess
 config.h
 config.h.in
 config.log
 config.status
+config.sub
 configure
+compile
+depcomp
 install-sh
+libtool
+ltmain.sh
+m4
 missing
 stamp-h1
+.deps
+.dirstamp
+.libs
+/src/facebook.c
+/src/google.c
+

=== modified file 'Makefile.am'
--- Makefile.am	2012-01-10 10:31:22 +0000
+++ Makefile.am	2012-03-14 11:55:04 +0000
@@ -1,3 +1,50 @@
 SUBDIRS = \
 	data \
 	tools
+
+# Plugins.
+plugin_LTLIBRARIES = \
+	libfacebook.la \
+	libgoogle.la
+
+VALAFLAGS = \
+	--vapidir $(top_srcdir)/src \
+	--pkg AccountPlugin \
+	--pkg accounts \
+	--pkg posix \
+	--pkg signon \
+	--pkg gtk+-3.0 \
+	--pkg gmodule-2.0
+
+plugin_cppflags = \
+	$(ACCOUNT_PLUGINS_CFLAGS) \
+	-include $(top_builddir)/config.h \
+	$(WARN_CFLAGS)
+
+plugin_libadd = \
+	$(ACCOUNT_PLUGINS_LIBS)
+
+plugin_ldflags = \
+	-export_dynamic \
+	-avoid-version \
+	-module \
+	-no-undefined \
+	-export-symbols-regex '^ap_module_get_object_type'
+
+libfacebook_la_CPPFLAGS = $(plugin_cppflags)
+libfacebook_la_LIBADD = $(plugin_libadd)
+libfacebook_la_LDFLAGS = $(plugin_ldflags)
+libfacebook_la_SOURCES = \
+	src/facebook.vala
+
+libgoogle_la_CPPFLAGS = $(plugin_cppflags)
+libgoogle_la_LIBADD = $(plugin_libadd)
+libgoogle_la_LDFLAGS = $(plugin_ldflags)
+libgoogle_la_SOURCES = \
+	src/google.vala
+
+dist_noinst_DATA = \
+	src/accounts.deps \
+	src/accounts.vapi \
+	src/signon.vapi \
+	src/AccountPlugin.vapi

=== added file 'acinclude.m4'
--- acinclude.m4	1970-01-01 00:00:00 +0000
+++ acinclude.m4	2012-03-14 11:55:04 +0000
@@ -0,0 +1,29 @@
+# -*- Mode: m4; indent-tabs-mode: nil; tab-width: 2 -*-
+#
+# Copyright (C) 2008, 2009 Free Software Foundation, Inc.
+#
+# This file is free software; the Free Software Foundation
+# gives unlimited permission to copy and/or distribute it,
+# with or without modifications, as long as this notice is preserved.
+
+# serial 4
+
+# Check whether the Vala compiler exists in `PATH'. If it is found, the
+# variable VALAC is set. Optionally a minimum release number of the
+# compiler can be requested.
+#
+# OVERRIDE_PROG_VALAC([MINIMUM-VERSION])
+# --------------------------------
+AC_DEFUN([OVERRIDE_PROG_VALAC],
+[AC_PATH_PROGS([VALAC], [$2], [])
+ AS_IF([test -z "$VALAC"],
+   [AC_MSG_ERROR([No Vala compiler found.])],
+   [AS_IF([test -n "$1"],
+      [AC_MSG_CHECKING([$VALAC is at least version $1])
+       am__vala_version=`$VALAC --version | sed 's/Vala  *//'`
+       AS_VERSION_COMPARE([$1], ["$am__vala_version"],
+         [AC_MSG_RESULT([yes])],
+         [AC_MSG_RESULT([yes])],
+         [AC_MSG_RESULT([no])
+          AC_MSG_ERROR([Vala $1 not found.])])])])
+])

=== modified file 'configure.ac'
--- configure.ac	2012-01-04 13:42:19 +0000
+++ configure.ac	2012-03-14 11:55:04 +0000
@@ -2,18 +2,28 @@
 
 AC_INIT(account-plugins, 0.1)
 
-AM_INIT_AUTOMAKE(AC_PACKAGE_NAME, AC_PACKAGE_VERSION)
+AM_INIT_AUTOMAKE([subdir-objects])
 AM_CONFIG_HEADER(config.h)
 
 # Gobject Introspection
 AC_CONFIG_MACRO_DIR([m4])
 GOBJECT_INTROSPECTION_CHECK([1.30.0])
 
-PKG_CHECK_MODULES(
-	LIBACCOUNTS,
-	libaccounts-glib)
-AC_SUBST(LIBACCOUNTS_CFLAGS)
-AC_SUBST(LIBACCOUNTS_LIBS)
+# Check for programs
+AC_PROG_CC
+AM_PROG_CC_C_O
+OVERRIDE_PROG_VALAC([0.15.1], [valac-0.16 valac-0.14 valac])
+
+LT_PREREQ([2.2])
+LT_INIT([disable-static])
+
+PKG_CHECK_MODULES(ACCOUNT_PLUGINS,
+	account-plugin)
+AC_SUBST(ACCOUNT_PLUGINS_CFLAGS)
+AC_SUBST(ACCOUNT_PLUGINS_LIBS)
+
+plugindir=`$PKG_CONFIG --variable plugindir account-plugin`
+AC_SUBST(plugindir)
 
 providersdir=`$PKG_CONFIG --variable providerfilesdir libaccounts-glib`
 AC_SUBST(providersdir)

=== added directory 'src'
=== added file 'src/AccountPlugin.vapi'
--- src/AccountPlugin.vapi	1970-01-01 00:00:00 +0000
+++ src/AccountPlugin.vapi	2012-03-14 11:55:04 +0000
@@ -0,0 +1,35 @@
+/* AccountPlugin.vapi generated by vapigen-0.16, do not modify. */
+
+[CCode (cprefix = "Ap", gir_namespace = "AccountPlugin", gir_version = "1.0", lower_case_cprefix = "ap_")]
+namespace Ap {
+	[CCode (cheader_filename = "libaccount-plugin/account-plugin.h", type_id = "ap_oauth_plugin_get_type ()")]
+	public class OAuthPlugin : Ap.Plugin {
+		[CCode (has_construct_function = false)]
+		protected OAuthPlugin ();
+		public void set_oauth_parameters (GLib.HashTable<string,GLib.Value?> oauth_params);
+		[NoAccessorMethod]
+		public GLib.HashTable<weak void*,weak void*> oauth_params { owned get; construct; }
+	}
+	[CCode (cheader_filename = "libaccount-plugin/account-plugin.h", type_id = "ap_plugin_get_type ()")]
+	public class Plugin : GLib.Object {
+		[CCode (has_construct_function = false)]
+		protected Plugin ();
+		public virtual unowned Gtk.Widget build_widget ();
+		public void emit_finished ();
+		public unowned Ag.Account get_account ();
+		public unowned GLib.Error get_error ();
+		public bool get_need_authentication ();
+		public unowned Ag.Provider get_provider ();
+		public bool get_user_cancelled ();
+		public void set_error (GLib.Error error);
+		public void set_need_authentication (bool need_authentication);
+		public void set_user_cancelled (bool cancelled);
+		public Ag.Account account { get; construct; }
+		public bool need_authentication { get; set; }
+		public signal void finished ();
+	}
+	[CCode (cheader_filename = "libaccount-plugin/account-plugin.h")]
+	public static Ap.Plugin client_load_plugin (Ag.Account account);
+	[CCode (cheader_filename = "libaccount-plugin/account-plugin.h")]
+	public static GLib.Type module_get_object_type ();
+}

=== added file 'src/accounts.deps'
--- src/accounts.deps	1970-01-01 00:00:00 +0000
+++ src/accounts.deps	2012-03-14 11:55:04 +0000
@@ -0,0 +1,1 @@
+gio-unix-2.0

=== added file 'src/accounts.vapi'
--- src/accounts.vapi	1970-01-01 00:00:00 +0000
+++ src/accounts.vapi	2012-03-14 11:55:04 +0000
@@ -0,0 +1,190 @@
+/* accounts.vapi generated by vapigen, do not modify. */
+
+[CCode (cprefix = "Ag", gir_namespace = "Accounts", gir_version = "1.0", lower_case_cprefix = "ag_")]
+namespace Ag {
+	[CCode (cheader_filename = "libaccounts-glib/accounts-glib.h", type_id = "ag_account_get_type ()")]
+	public class Account : GLib.Object {
+		[CCode (has_construct_function = false)]
+		protected Account ();
+		public void @delete ();
+		public unowned string get_display_name ();
+		public bool get_enabled ();
+		public unowned Ag.Manager get_manager ();
+		public unowned string get_provider_name ();
+		public Ag.Service get_selected_service ();
+		public Ag.AccountSettingIter get_settings_iter (string? key_prefix);
+		public Ag.SettingSource get_value (string key, GLib.Value value);
+		public GLib.List<Ag.Service> list_enabled_services ();
+		public GLib.List<Ag.Service> list_services ();
+		public GLib.List<Ag.Service> list_services_by_type (string service_type);
+		public void remove_watch (Ag.AccountWatch watch);
+		public void select_service (Ag.Service? service);
+		public void set_display_name (string display_name);
+		public void set_enabled (bool enabled);
+		public void set_value (string key, GLib.Value? value);
+		public void settings_iter_init (Ag.AccountSettingIter iter, string? key_prefix);
+		public void sign (string key, string token);
+		public void store (Ag.AccountStoreCb callback);
+		public bool store_blocking () throws GLib.Error;
+		public bool supports_service (string service_type);
+		public bool verify (string key, string token);
+		public bool verify_with_tokens (string key, string tokens);
+		public unowned Ag.AccountWatch watch_dir (string key_prefix, Ag.AccountNotifyCb callback);
+		public unowned Ag.AccountWatch watch_key (string key, Ag.AccountNotifyCb callback);
+		public bool foreign { construct; }
+		[NoAccessorMethod]
+		public uint id { get; construct; }
+		public Ag.Manager manager { construct; }
+		public string provider { construct; }
+		public signal void deleted ();
+		public signal void display_name_changed ();
+		public signal void enabled (string service, bool enabled);
+	}
+	[CCode (cheader_filename = "libaccounts-glib/accounts-glib.h", type_id = "ag_account_service_get_type ()")]
+	public class AccountService : GLib.Object {
+		[CCode (has_construct_function = false)]
+		public AccountService (owned Ag.Account account, owned Ag.Service service);
+		public unowned Ag.Account get_account ();
+		[CCode (array_length = false, array_null_terminated = true)]
+		public string[] get_changed_fields ();
+		public bool get_enabled ();
+		public unowned Ag.Service get_service ();
+		public Ag.AccountSettingIter get_settings_iter (string? key_prefix);
+		public Ag.SettingSource get_value (string key, GLib.Value value);
+		public void set_value (string key, GLib.Value? value);
+		public void settings_iter_init (Ag.AccountSettingIter iter, string? key_prefix);
+		public static bool settings_iter_next (Ag.AccountSettingIter iter, out unowned string key, out GLib.Value value);
+		public Ag.Account account { construct; }
+		public Ag.Service service { construct; }
+		public signal void changed ();
+		public signal void enabled (bool enabled);
+	}
+	[CCode (cheader_filename = "libaccounts-glib/accounts-glib.h", copy_function = "g_boxed_copy", free_function = "g_boxed_free", lower_case_csuffix = "account_settings_iter", type_id = "ag_account_settings_iter_get_type ()")]
+	[Compact]
+	public class AccountSettingIter {
+		public weak Ag.Account account;
+		public void free ();
+		public bool next (out unowned string key, out GLib.Value value);
+	}
+	[CCode (cheader_filename = "libaccounts-glib/accounts-glib.h")]
+	[Compact]
+	public class AccountWatch {
+	}
+	[CCode (cheader_filename = "libaccounts-glib/accounts-glib.h", copy_function = "g_boxed_copy", free_function = "g_boxed_free", type_id = "ag_application_get_type ()")]
+	[Compact]
+	public class Application {
+		public unowned string get_description ();
+		public GLib.DesktopAppInfo get_desktop_app_info ();
+		public unowned string get_i18n_domain ();
+		public unowned string get_name ();
+		public unowned string get_service_usage (Ag.Service service);
+		public Ag.Application @ref ();
+		public void unref ();
+	}
+	[CCode (cheader_filename = "libaccounts-glib/accounts-glib.h", type_id = "ag_manager_get_type ()")]
+	public class Manager : GLib.Object {
+		[CCode (has_construct_function = false)]
+		public Manager ();
+		public Ag.Account create_account (string provider_name);
+		[CCode (has_construct_function = false)]
+		public Manager.for_service_type (string service_type);
+		public bool get_abort_on_db_timeout ();
+		public Ag.Account get_account (Ag.AccountId account_id);
+		public GLib.List<Ag.AccountService> get_account_services ();
+		public Ag.Application get_application (string application_name);
+		public uint get_db_timeout ();
+		public GLib.List<Ag.AccountService> get_enabled_account_services ();
+		public Ag.Provider get_provider (string provider_name);
+		public Ag.Service get_service (string service_name);
+		public unowned string get_service_type ();
+		public GLib.List<uint> list ();
+		public GLib.List<Ag.Application> list_applications_by_service (Ag.Service service);
+		public GLib.List<uint> list_by_service_type (string service_type);
+		public GLib.List<uint> list_enabled ();
+		public GLib.List<uint> list_enabled_by_service_type (string service_type);
+		public static void list_free (GLib.List<uint> list);
+		public GLib.List<Ag.Provider> list_providers ();
+		public GLib.List<Ag.Service> list_services ();
+		public GLib.List<Ag.Service> list_services_by_type (string service_type);
+		public Ag.Account load_account (Ag.AccountId account_id) throws GLib.Error;
+		public Ag.ServiceType load_service_type (string service_type);
+		public void set_abort_on_db_timeout (bool abort);
+		public void set_db_timeout (uint timeout_ms);
+		public string service_type { construct; }
+		public signal void account_created (uint account_id);
+		public virtual signal void account_deleted (uint id);
+		public signal void account_updated (uint account_id);
+		public signal void enabled_event (uint account_id);
+	}
+	[CCode (cheader_filename = "libaccounts-glib/accounts-glib.h", copy_function = "g_boxed_copy", free_function = "g_boxed_free", type_id = "ag_provider_get_type ()")]
+	[Compact]
+	public class Provider {
+		public unowned string get_display_name ();
+		public void get_file_contents (string contents);
+		public unowned string get_i18n_domain ();
+		public unowned string get_icon_name ();
+		public unowned string get_name ();
+		public static void list_free (GLib.List<Ag.Provider> list);
+		public Ag.Provider @ref ();
+		public void unref ();
+	}
+	[CCode (cheader_filename = "libaccounts-glib/accounts-glib.h", copy_function = "g_boxed_copy", free_function = "g_boxed_free", type_id = "ag_service_get_type ()")]
+	[Compact]
+	public class Service {
+		public unowned string get_display_name ();
+		public void get_file_contents (string contents, size_t data_offset);
+		public unowned string get_i18n_domain ();
+		public unowned string get_icon_name ();
+		public unowned string get_name ();
+		public unowned string get_provider ();
+		public unowned string get_service_type ();
+		public static void list_free (GLib.List<Ag.Service> list);
+		public Ag.Service @ref ();
+		public void unref ();
+	}
+	[CCode (cheader_filename = "libaccounts-glib/accounts-glib.h", copy_function = "g_boxed_copy", free_function = "g_boxed_free", type_id = "ag_service_type_get_type ()")]
+	[Compact]
+	public class ServiceType {
+		public unowned string get_display_name ();
+		public void get_file_contents (string contents, size_t len);
+		public unowned string get_i18n_domain ();
+		public unowned string get_icon_name ();
+		public unowned string get_name ();
+		public Ag.ServiceType @ref ();
+		public void unref ();
+	}
+	[CCode (cheader_filename = "libaccounts-glib/accounts-glib.h")]
+	[SimpleType]
+	public struct AccountId : uint {
+	}
+	[CCode (cheader_filename = "libaccounts-glib/accounts-glib.h")]
+	public enum Error {
+		[CCode (cname = "AG_ERROR_DB")]
+		DB,
+		[CCode (cname = "AG_ERROR_DISPOSED")]
+		DISPOSED,
+		[CCode (cname = "AG_ERROR_DELETED")]
+		DELETED,
+		[CCode (cname = "AG_ERROR_DB_LOCKED")]
+		DB_LOCKED,
+		[CCode (cname = "AG_ERROR_ACCOUNT_NOT_FOUND")]
+		ACCOUNT_NOT_FOUND
+	}
+	[CCode (cheader_filename = "libaccounts-glib/accounts-glib.h")]
+	public enum SettingSource {
+		[CCode (cname = "AG_SETTING_SOURCE_NONE")]
+		NONE,
+		[CCode (cname = "AG_SETTING_SOURCE_ACCOUNT")]
+		ACCOUNT,
+		[CCode (cname = "AG_SETTING_SOURCE_PROFILE")]
+		PROFILE
+	}
+	[CCode (cheader_filename = "libaccounts-glib/accounts-glib.h", instance_pos = 2.9)]
+	public delegate void AccountNotifyCb (Ag.Account account, string key);
+	[CCode (cheader_filename = "libaccounts-glib/accounts-glib.h", instance_pos = 2.9)]
+	public delegate void AccountServiceNotifyCb (Ag.AccountService self, string key);
+	[CCode (cheader_filename = "libaccounts-glib/accounts-glib.h", instance_pos = 2.9)]
+	public delegate void AccountStoreCb (Ag.Account account, GLib.Error error);
+	[CCode (cheader_filename = "libaccounts-glib/accounts-glib.h")]
+	public static GLib.Quark errors_quark ();
+}

=== added file 'src/facebook.vala'
--- src/facebook.vala	1970-01-01 00:00:00 +0000
+++ src/facebook.vala	2012-03-14 11:55:04 +0000
@@ -0,0 +1,44 @@
+/*
+ * Copyright (C) 2012 Canonical, Inc
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
+ * USA.
+ *
+ * Authors:
+ *      Alberto Mardegan <alberto.mardegan@canonical.com>
+ */
+
+public class FacebookPlugin : Ap.OAuthPlugin {
+    public FacebookPlugin (Ag.Account account) {
+        Object (account: account);
+    }
+
+    construct
+    {
+        var oauth_params = new HashTable<string, GLib.Value?> (str_hash, null);
+        oauth_params.insert ("Host", "www.facebook.com");
+        oauth_params.insert ("AuthPath", "/dialog/oauth");
+        oauth_params.insert ("RedirectUri",
+                             "https://www.facebook.com/connect/login_success.html");
+        oauth_params.insert ("ClientId", "213156715390803");
+        oauth_params.insert ("Display", "popup");
+        set_oauth_parameters (oauth_params);
+    }
+}
+
+public GLib.Type ap_module_get_object_type ()
+{
+    return typeof (FacebookPlugin);
+}

=== added file 'src/google.vala'
--- src/google.vala	1970-01-01 00:00:00 +0000
+++ src/google.vala	2012-03-14 11:55:04 +0000
@@ -0,0 +1,46 @@
+/*
+ * Copyright (C) 2012 Canonical, Inc
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
+ * USA.
+ *
+ * Authors:
+ *      Alberto Mardegan <alberto.mardegan@canonical.com>
+ */
+
+public class GooglePlugin : Ap.OAuthPlugin {
+    public GooglePlugin (Ag.Account account) {
+        Object (account: account);
+    }
+
+    construct
+    {
+        var oauth_params = new HashTable<string, GLib.Value?> (str_hash, null);
+        oauth_params.insert ("Host", "accounts.google.com");
+        oauth_params.insert ("AuthPath", "o/oauth2/auth");
+        oauth_params.insert ("RedirectUri",
+                             "http://www.mardy.it/oauth2callback");
+        oauth_params.insert ("ClientId",
+                             "1041829795610-htf69c529db58qcq8jvf58bijn1ie3oi.apps.googleusercontent.com");
+        oauth_params.insert ("ResponseType", "token");
+        oauth_params.insert ("Scope", "https://picasaweb.google.com/data/");
+        set_oauth_parameters (oauth_params);
+    }
+}
+
+public GLib.Type ap_module_get_object_type ()
+{
+    return typeof (GooglePlugin);
+}

=== added file 'src/signon.vapi'
--- src/signon.vapi	1970-01-01 00:00:00 +0000
+++ src/signon.vapi	2012-03-14 11:55:04 +0000
@@ -0,0 +1,166 @@
+/* signon.vapi generated by vapigen, do not modify. */
+
+[CCode (cprefix = "Signon", gir_namespace = "Signon", gir_version = "1.0", lower_case_cprefix = "signon_")]
+namespace Signon {
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", type_id = "signon_auth_service_get_type ()")]
+	public class AuthService : GLib.Object {
+		[CCode (has_construct_function = false)]
+		public AuthService ();
+		public void query_mechanisms (string method, Signon.QueryMechanismCb cb);
+		public void query_methods (Signon.QueryMethodsCb cb);
+	}
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", type_id = "signon_auth_session_get_type ()")]
+	public class AuthSession : GLib.Object {
+		[CCode (has_construct_function = false)]
+		public AuthSession (int id, string method_name) throws GLib.Error;
+		public void cancel ();
+		public unowned string get_method ();
+		public void process (GLib.HashTable<string,GLib.Value?> session_data, string mechanism, Signon.AuthSessionProcessCb cb);
+		public void query_available_mechanisms (string wanted_mechanisms, Signon.AuthSessionQueryAvailableMechanismsCb cb);
+		public signal void state_changed (int object, string p0);
+	}
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", type_id = "signon_identity_get_type ()")]
+	public class Identity : GLib.Object {
+		[CCode (has_construct_function = false)]
+		public Identity ();
+		public void add_reference (string reference, Signon.IdentityReferenceAddedCb cb, void* user_data);
+		public Signon.AuthSession create_session (string method) throws GLib.Error;
+		[CCode (has_construct_function = false)]
+		public Identity.from_db (uint32 id);
+		public unowned GLib.Error get_last_error ();
+		public void query_info (Signon.IdentityInfoCb cb);
+		public void remove (Signon.IdentityRemovedCb cb, void* user_data);
+		public void remove_reference (string reference, Signon.IdentityReferenceRemovedCb cb, void* user_data);
+		public void store_credentials_with_args (string username, string secret, bool store_secret, GLib.HashTable<string,string[]> methods, string caption, string realms, string access_control_list, Signon.IdentityType type, Signon.IdentityStoreCredentialsCb cb);
+		public void store_credentials_with_info (Signon.IdentityInfo info, Signon.IdentityStoreCredentialsCb cb);
+		public void verify_secret (string secret, Signon.IdentityVerifyCb cb);
+		[NoAccessorMethod]
+		public uint id { get; set; }
+		[HasEmitter]
+		public signal void signout ();
+	}
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", copy_function = "g_boxed_copy", free_function = "g_boxed_free", type_id = "signon_identity_info_get_type ()")]
+	[Compact]
+	public class IdentityInfo {
+		[CCode (has_construct_function = false)]
+		public IdentityInfo ();
+		public Signon.IdentityInfo copy ();
+		public void free ();
+		[CCode (array_length = false, array_null_terminated = true)]
+		public unowned string[] get_access_control_list ();
+		public unowned string get_caption ();
+		public int get_id ();
+		public Signon.IdentityType get_identity_type ();
+		public unowned GLib.HashTable<string,string[]> get_methods ();
+		[CCode (array_length = false, array_null_terminated = true)]
+		public unowned string[] get_realms ();
+		public bool get_storing_secret ();
+		public unowned string get_username ();
+		public void remove_method (string method);
+		public void set_access_control_list (string access_control_list);
+		public void set_caption (string caption);
+		public void set_identity_type (Signon.IdentityType type);
+		public void set_method (string method, string mechanisms);
+		public void set_realms (string realms);
+		public void set_secret (string secret, bool store_secret);
+		public void set_username (string username);
+	}
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cprefix = "SIGNON_IDENTITY_TYPE_")]
+	[Flags]
+	public enum IdentityType {
+		OTHER,
+		APP,
+		WEB,
+		NETWORK
+	}
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cprefix = "SIGNON_POLICY_")]
+	public enum SessionDataUiPolicy {
+		DEFAULT,
+		REQUEST_PASSWORD,
+		NO_USER_INTERACTION,
+		VALIDATION
+	}
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cprefix = "SIGNON_ERROR_")]
+	public errordomain Error {
+		UNKNOWN,
+		INTERNAL_SERVER,
+		INTERNAL_COMMUNICATION,
+		PERMISSION_DENIED,
+		METHOD_NOT_KNOWN,
+		SERVICE_NOT_AVAILABLE,
+		INVALID_QUERY,
+		METHOD_NOT_AVAILABLE,
+		IDENTITY_NOT_FOUND,
+		STORE_FAILED,
+		REMOVE_FAILED,
+		SIGNOUT_FAILED,
+		IDENTITY_OPERATION_CANCELED,
+		CREDENTIALS_NOT_AVAILABLE,
+		REFERENCE_NOT_FOUND,
+		MECHANISM_NOT_AVAILABLE,
+		MISSING_DATA,
+		INVALID_CREDENTIALS,
+		NOT_AUTHORIZED,
+		WRONG_STATE,
+		OPERATION_NOT_SUPPORTED,
+		NO_CONNECTION,
+		NETWORK,
+		SSL,
+		RUNTIME,
+		SESSION_CANCELED,
+		TIMED_OUT,
+		USER_INTERACTION,
+		OPERATION_FAILED,
+		ENCRYPTION_FAILED,
+		TOS_NOT_ACCEPTED,
+		FORGOT_PASSWORD,
+		METHOD_OR_MECHANISM_NOT_ALLOWED,
+		INCORRECT_DATE,
+		USER_ERROR;
+		public static GLib.Quark quark ();
+	}
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 3.9)]
+	public delegate void AuthSessionProcessCb (Signon.AuthSession self, owned GLib.HashTable<string,GLib.Value?> session_data, GLib.Error error);
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 3.9)]
+	public delegate void AuthSessionQueryAvailableMechanismsCb (Signon.AuthSession self, [CCode (array_length = false, array_null_terminated = true)] owned string[] mechanisms, GLib.Error error);
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 3.9)]
+	public delegate void AuthSessionQueryAvailableMethodsCb (Signon.AuthSession self, [CCode (array_length = false, array_null_terminated = true)] owned string[] mechanisms, GLib.Error error);
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 3.9)]
+	public delegate void IdentityInfoCb (Signon.Identity self, Signon.IdentityInfo info, GLib.Error error);
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 2.9)]
+	public delegate void IdentityReferenceAddedCb (Signon.Identity self, GLib.Error error);
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 2.9)]
+	public delegate void IdentityReferenceRemovedCb (Signon.Identity self, GLib.Error error);
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 2.9)]
+	public delegate void IdentityRemovedCb (Signon.Identity self, GLib.Error error);
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 2.9)]
+	public delegate void IdentitySignedOutCb (Signon.Identity self, GLib.Error error);
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 3.9)]
+	public delegate void IdentityStoreCredentialsCb (Signon.Identity self, uint32 id, GLib.Error error);
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 3.9)]
+	public delegate void IdentityVerifyCb (Signon.Identity self, bool valid, GLib.Error error);
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 2.9)]
+	public delegate void IdentityVoidCb (Signon.Identity self, GLib.Error error);
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 4.9)]
+	public delegate void QueryMechanismCb (Signon.AuthService auth_service, string method, [CCode (array_length = false, array_null_terminated = true)] owned string[] mechanisms, GLib.Error error);
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", instance_pos = 3.9)]
+	public delegate void QueryMethodsCb (Signon.AuthService auth_service, [CCode (array_length = false, array_null_terminated = true)] owned string[] methods, GLib.Error error);
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cname = "SIGNON_SESSION_DATA_CAPTION")]
+	public const string SESSION_DATA_CAPTION;
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cname = "SIGNON_SESSION_DATA_PROXY")]
+	public const string SESSION_DATA_PROXY;
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cname = "SIGNON_SESSION_DATA_REALM")]
+	public const string SESSION_DATA_REALM;
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cname = "SIGNON_SESSION_DATA_RENEW_TOKEN")]
+	public const string SESSION_DATA_RENEW_TOKEN;
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cname = "SIGNON_SESSION_DATA_SECRET")]
+	public const string SESSION_DATA_SECRET;
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cname = "SIGNON_SESSION_DATA_TIMEOUT")]
+	public const string SESSION_DATA_TIMEOUT;
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cname = "SIGNON_SESSION_DATA_UI_POLICY")]
+	public const string SESSION_DATA_UI_POLICY;
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cname = "SIGNON_SESSION_DATA_USERNAME")]
+	public const string SESSION_DATA_USERNAME;
+	[CCode (cheader_filename = "libsignon-glib/signon-glib.h", cname = "SIGNON_SESSION_DATA_WINDOW_ID")]
+	public const string SESSION_DATA_WINDOW_ID;
+}

